package com.lutao.carlocation.service.impl;

import cn.hutool.core.lang.UUID;
import cn.hutool.json.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.lutao.carlocation.entity.IsolatedVehicleLocationMonitor;
import com.lutao.carlocation.mapper.IsolatedVehicleLocationMonitorMapper;
import com.lutao.carlocation.service.IsolatedVehicleLocationMonitorService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

/**
 * 危化品车辆实时定位serviceImpl
 *
 * @author yx
 * @date 2023/10/23
 */
@Service
@Slf4j
public class IsolatedVehicleLocationMonitorServiceImpl extends ServiceImpl<IsolatedVehicleLocationMonitorMapper, IsolatedVehicleLocationMonitor> implements IsolatedVehicleLocationMonitorService {


    @Override
    public void saveSendMessage(JSONObject sendMessage) {

        try {
            IsolatedVehicleLocationMonitor isolatedVehicleLocationMonitor = new IsolatedVehicleLocationMonitor();
            isolatedVehicleLocationMonitor.setId(String.valueOf(UUID.randomUUID()));
            isolatedVehicleLocationMonitor.setLocaterCode((String) sendMessage.get("vehicleNO"));

            String positioningTime = sendMessage.getStr("positioningTime");
            DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
            LocalDateTime dateTime = LocalDateTime.parse(positioningTime, formatter);
            isolatedVehicleLocationMonitor.setLocatingTime(dateTime);

            isolatedVehicleLocationMonitor.setLatitude(sendMessage.getDouble("latitude"));
            isolatedVehicleLocationMonitor.setLongitude(sendMessage.getDouble("longitude"));

            isolatedVehicleLocationMonitor.setLocaterCode(sendMessage.getStr("vehicleNO"));

            isolatedVehicleLocationMonitor.setCreateTime(LocalDateTime.now());
            isolatedVehicleLocationMonitor.setCreateTime(LocalDateTime.now());

            save(isolatedVehicleLocationMonitor);
        }catch (Exception e){
            log.error("保存消息失败");
            e.printStackTrace();
        }


    }
}
